"""Twitter database models."""
from datetime import datetime

from umongo import Document, fields

from jarvis_core.db import JARVIS_INST


@JARVIS_INST.register
class TwitterAccount(Document):
    """Twitter Account object."""

    handle = fields.StringField(required=True)
    twitter_id = fields.IntegerField(required=True)
    last_tweet = fields.IntegerField(required=True)
    last_sync = fields.DateTimeField(default=datetime.utcnow)

    class Meta:
        collection_name = "twitteraccount"


@JARVIS_INST.register
class TwitterFollow(Document):
    """Twitter Follow object."""

    active = fields.BooleanField(default=True)
    twitter_id = fields.IntegerField(required=True)
    channel = fields.IntegerField(required=True)
    guild = fields.IntegerField(required=True)
    retweets = fields.BooleanField(default=True)
    admin = fields.IntegerField(required=True)
    created_at = fields.DateTimeField(default=datetime.utcnow)

    class Meta:
        collection_name = "twitterfollow"
